{$mode objfpc}{$H-}{$R+}{$T+}{$Q+}{$V+}{$D+}{$X-}{$warnings on}
program ecuaciones_grado2;
uses math;

// Resolución de ecuaciones de 2º grado 

const
	Epsilon: real = 0.00001;

function discriminante(a, b, c: real): real;
begin
	result := b ** 2 - 4.0 * a * c;
end;

function tiene_solucion(a, b, c: real): boolean;
begin
	result := (discriminante(a, b, c) >= 0.0) and (a <> 0.0);
   
end;

procedure resuelve_ecuacion(a, b, c: real; var x1, x2: real);
begin
	x1 := (-b + sqrt(discriminante(a, b, c))) / (2.0 * a);
	x2 := (-b - sqrt(discriminante(a, b, c))) / (2.0 * a);
end;

procedure escribe_solucion(a, b, c: real; x1, x2: real);
begin
	writeln(a:0:2, '*x**2 + ', b:0:2, '*x +', c:0:2, ' = 0');
	if abs(x1-x2) < Epsilon then 
		writeln(' x = ', x1:0:2)
	else begin
		writeln(' x1 = ', x1:0:2);
		writeln(' x2 = ', x2:0:2)
	end;
end;

var
	
a, b, c: real;	 { ax2+xb+c=0 }
x1, x2: real;

begin   // Cuerpo principal
	a := 3.0 ;
	b := 7.2 ;
	c := 1.1 ;
	
	if tiene_solucion(a, b, c) 
	then begin
		resuelve_ecuacion(a, b, c, x1, x2);
		escribe_solucion(a, b, c, x1, x2);
	end
	else 
		writeln('sin solucion');
end.
